/* How many times can you call malloc(0) before it fails?

   WARNING:  This program repeatedly calls malloc(0) until it returns
   NULL, reporting how many times it returned non-NULL.  Note that
   this program deliberately attempts to exhaust available memory,
   which might have negative consequences for the system on which it
   runs.  Understand the consequences before compiling and running.

   Author:  Terence Kelly

   For "Drill Bits" column in Jan/Feb 2023 ACM _Queue_ magazine.

   https://queue.acm.org/DrillBits

   On Linux systems, the "OOM (out-of-memory) killer" might
   terminate this process before malloc() returns NULL.
*/

#include <stdio.h>
#include <stdlib.h>

int main(void) {
  void *p;  unsigned long int n = 0, t = 1;
  for (;;) {
    if (NULL != (p = malloc(0))) {
      if (++n == t) {
        printf("succeed at %lu\n", n);
        t *= 2;
      }
    }
    else {
      printf("failed after %lu\n", n);
      break;
    }
  }
  return 0;
}
