/* sane library (interface); see sane.c for notes
   Copyright (C) 2023  Terence Kelly

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU Affero General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU Affero General Public License for more details.

   You should have received a copy of the GNU Affero General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef SANE_H_INCLUDED
#define SANE_H_INCLUDED

extern void * sane_malloc(size_t size);
extern void * sane_calloc(size_t nmemb, size_t size);
extern void * sane_realloc(void *ptr, size_t size);

#ifdef SANE_STANDARDIZE
#define malloc  sane_malloc
#define calloc  sane_calloc
#define realloc sane_realloc
#endif

#endif
